import os

from PySide2.QtCore import QFile
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QDialog

from TableStatistic.ui.formStatistic import FormStatistic


def load_ui( name_resource,parent):
    loader = QUiLoader()
    path = os.path.join(os.path.dirname(__file__), name_resource)
    ui_file = QFile(path)
    ui_file.open(QFile.ReadOnly)
    ui = loader.load(ui_file, parent)

    ui_file.close()
    return ui

class DlgTest(QDialog):
    def __init__(self,parent=None):
        super().__init__(parent)
        self.ui=load_ui("testDlg.ui",parent)
        self.__w_form=FormStatistic(self.ui)
        self.ui.verticalLayout.addWidget(self.__w_form)
    def show(self):
        self.ui.show()
