from axipy import Table


def FildsNumber(tab:Table)->list:
    schema_tab=tab.schema
    count_fields=len(schema_tab)
    list_numeric_field=[]
    for i in range(count_fields):
        att=schema_tab[i]
        if att.type_string=='decimal' or att.type_string=='double' or att.type_string=='float' or att.type_string=='int' or att.type_string=='large':
            list_numeric_field.append(att.name)
    if len(list_numeric_field)==0:
        return None
    return list_numeric_field
def itemSqlFields(field_name):
    sql="Min("+field_name+"),Max("+field_name+"),Sum("+field_name+"),avg("+field_name+"),(avg("+field_name+"*"+field_name+")- avg("+field_name+")* avg("+field_name+")) as std_"+field_name
    return sql
def createSqlStatistic(list_fields)->str:
    list_item_sql=[]
    for name in list_fields:
        list_item_sql.append(itemSqlFields(name))
    sql="Select Count(*),"+",".join(list_item_sql)
    return sql
def statistic_field_info(name_field,data,start_index):
    stat_info={'name':name_field,"info":{}}
    stat_info['info']['min']=data[start_index]
    stat_info['info']['max'] = data[start_index+1]
    stat_info['info']['sum'] = data[start_index + 2]
    stat_info['info']['avg'] = data[start_index + 3]
    stat_info['info']['std'] = data[start_index + 4]
    return stat_info
def tab_sql_toList(tab:Table,name_fields):
    fts=list(tab.items())
    item_ft=fts[0]
    count=len(item_ft)
    all_count=item_ft[0]
    id_name=0
    result_info= {"count":all_count,'fields':[]}
    fields_info=result_info['fields']
    for i in range(1,count,5):
        stat_info_field=statistic_field_info(name_fields[id_name],item_ft,i)
        id_name=id_name+1
        fields_info.append(stat_info_field)
    return result_info





