import os

import axipy
from PySide2.QtGui import QIcon
from axipy import Plugin, Position, ObserverManager, view_manager, data_manager

from TableStatistic.ui.add_tools.observer import factoryObserverTabVector
from TableStatistic.ui.docWidget import DelDocWidget, AxiDocWidget, addDoc, existDocWidget
from TableStatistic.ui.formStatistic import FormStatistic


class PluginSmothGeometry(Plugin):
    def __init__(self) -> None:
        self.__form_tool = None
        self.__docWidget = None
        self.__name="Расширенная статистика"

        self.__name_observer="VectorTableOneAny"
        self.__observer=factoryObserverTabVector(self.__name_observer)
        self.__observer.changed.connect(self.__changeValueObserver)

        self._title = self.tr("Расширенная статистика")

        local_file_icon_1 = os.path.join(os.path.dirname(os.path.realpath(__file__)), 'icons', 'statistic.png')

        self.__action_statistic = self.create_action('Расширенная статистика',
                                           icon=local_file_icon_1, on_click=self.run_statistic,
                                           enable_on=self.__name_observer)

        position = Position('Таблица', 'Действие')
        position.add(self.__action_statistic)

    def unload(self):
        if self.__docWidget is not None:
            DelDocWidget(view_manager.global_parent, self.__docWidget)
            # self.__observer.removeChildrenWidget(self.__name_observer)

            self.__docWidget = None
            self.__form_tool = None

        self.__action_statistic.remove()

    def run_statistic(self):
        if self.__form_tool is None:
            self.__form_tool =FormStatistic(view_manager.global_parent)

        if self.__docWidget is None:

            self.__docWidget=AxiDocWidget(self.__form_tool.widget,"Расширенная статистика по таблицам",self.__name,QIcon(),view_manager.global_parent)
            addDoc(axipy.app.mainwindow.qt_object(),self.__docWidget)
        else:
            isExist=existDocWidget(view_manager.global_parent,self.__docWidget)
            self.__docWidget.setVisible(True)
            self.__docWidget.setFocus()
            self.__docWidget.raise_()
    def __changeValueObserver(self):
        value_observer=self.__observer.value
        print("Observer change")
        print(value_observer)
        if self.__form_tool is not None:

            if not value_observer:
                if len(data_manager.tables)==0:
                    self.__form_tool.widget.setEnabled(False)
                    #print("Disable plagin")
            else:
                self.__form_tool.widget.setEnabled(True)

