from PySide2.QtCore import QObject, Signal
from axipy import Table, AxipyProgressHandler, data_manager

from TableStatistic.ui.add_tools.helper_tab import FildsNumber, createSqlStatistic, tab_sql_toList


class CalcStatistic(QObject):
    end_task=Signal()
    def __init__(self,tab:Table):
        super().__init__()
        self.__tab=tab
        self.__fields_statistic=None
    @property
    def result(self):
        return self.__fields_statistic
    def run(self,ph: AxipyProgressHandler,parm):
        try:
            list_fields = FildsNumber(self.__tab)
            sql = createSqlStatistic(list_fields)
            sql_run = sql + " From " + self.__tab.name
            tab_sql = data_manager.query_hidden(sql_run)
            statistic_info = tab_sql_toList(tab_sql, list_fields)
            tab_sql.close()

            self.__fields_statistic = statistic_info
        except:
            self.__fields_statistic=None
        self.end_task.emit()
        return ph.progress()